<template>
  <b-row class="run">
    <b-col md="8">
      <Loading :loading="this.$apollo.queries.run.loading" />

      <div v-if="!this.$apollo.queries.run.loading">
        <p class="caption">
          Run of
          <router-link class="caption" :to="`/test/${run.test.id}`">
            {{ run.test.name }}
          </router-link>
          with build
          <router-link class="caption" :to="`/build/${run.build.id}`">
            {{ run.build.tag }}
          </router-link>
          of system
          <router-link class="caption" :to="`/system/${run.test.system.id}`">
            {{ run.test.system.name }}
          </router-link>
        </p>
        <h1><RunResult :result="run.result" /></h1>
        <RunControls :run="run" />
        <p>
          Comment: <i>{{ run.comment || "no comment" }}</i>
        </p>
        <p>
          Submitted by:
          <router-link v-if="run.user" :to="`/user/${run.user.id}`">
            {{ run.user.name }}
          </router-link>
          <nobr v-show="!run.user">
            Anonymous user
          </nobr>
          on {{ new Date(Number(run.date)).toLocaleString() }}
        </p>

        <b-table
          v-if="run.combination"
          v-show="run.combination[0]"
          :items="run.combination"
          :fields="['variable', 'value']"
          class="mt-3"
          outlined
          striped
        />

        <div v-show="run.logs.length">
          <h2>Logs</h2>
          <p>
            For security purposes, logs are only visible to moderators and the
            account that submitted them.
          </p>
          <div
            v-for="(log, index) in run.logs.length"
            v-bind:key="`log-${index}`"
            class="log"
          >
            <h3>{{ run.logs[index].name }}</h3>
            <pre>{{ run.logs[index].content }}</pre>
          </div>
        </div>
      </div>
    </b-col>

    <SystemSidebar md="4" :system="run.test.system" />
  </b-row>
</template>

<script>
import Loading from "@/components/Loading.vue";
import RunControls from "@/components/RunControls.vue";
import SystemSidebar from "@/components/SystemSidebar.vue";
import RunResult from "@/components/RunResult.vue";
import gql from "graphql-tag";

export default {
  name: "Run",
  data() {
    return {
      run: {
        id: this.$route.params.id,
        user: {},
        test: { system: {} },
        build: {},
        logs: []
      }
    };
  },
  components: {
    Loading,
    RunControls,
    SystemSidebar,
    RunResult
  },
  apollo: {
    run: {
      query: gql`
        query run($runId: ID!) {
          run(id: $runId) {
            id
            date
            result
            comment
            logs {
              name
              content
            }
            combination {
              variable
              value
            }
            user {
              id
              name
            }
            test {
              id
              name
              system {
                id
                name
                description
                image
                tests {
                  id
                  name
                  description
                }
                builds {
                  id
                  tag
                }
                combinationFilter
                properties {
                  id
                  name
                  description
                  values
                }
              }
            }
            build {
              id
              tag
            }
          }
        }
      `,
      variables() {
        return {
          runId: this.$route.params.id
        };
      },
      error() {
        this.$router.push({ path: `/dashboard/` });
      }
    }
  }
};
</script>
